--
-- AutoBarConfigSlot
--
-- Slot Config functions
--
-- Maintained by Azethoth / Toadkiller of Proudmoore.
-- http://www.curse-gaming.com/en/wow/addons-4430-1-autobar-toadkiller.html
--

--
-- Config Checkbox Handling
--

AutoBarConfigSlot = {};


function AutoBarConfigSlot:View(slotsIndex, playerInfo)
	AutoBarConfigSlotFrameTitleText:SetText(AUTOBAR_CONFIG_VIEWBUTTON);
	AutoBarConfigSlotFrameViewText:Show();
	AutoBarConfigSlot.editable = false;
	AutoBarConfigSlot:Initialize(slotsIndex, playerInfo);
	AutoBarConfigSlotFrameConvertButton:Hide();
	AutoBarConfigSlotFrameClearSlotButton:Hide();
	AutoBarConfigSlotFrameEmptySlotButton:Hide();
	AutoBarConfigSlotFrameNoPopup:Disable();
	AutoBarConfigSlotFrameArrangeOnUse:Disable();
	AutoBarConfigSlotFrameRightClickTargetsPet:Disable();
	AutoBarConfigSlotFrameNoPopupText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	AutoBarConfigSlotFrameArrangeOnUseText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	AutoBarConfigSlotFrameRightClickTargetsPetText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	AutoBarConfigSlotFrame:SetBackdropColor(0.30,0.15,0.15);
end


function AutoBarConfigSlot:Edit(slotsIndex, playerInfo)
	AutoBarConfigSlotFrameTitleText:SetText(AUTOBAR_CONFIG_EDITBUTTON.." #" .. slotsIndex);
	AutoBarConfigSlotFrameViewText:Hide();
	AutoBarConfigSlot.editable = true;
	AutoBarConfigSlot:Initialize(slotsIndex, playerInfo);
	AutoBarConfigSlotFrameConvertButton:Show();
	AutoBarConfigSlotFrameClearSlotButton:Show();
	AutoBarConfigSlotFrameEmptySlotButton:Show();
	AutoBarConfigSlotFrame:SetBackdropColor(0.15,0.20,0.15);
end


function AutoBarConfigSlot:Initialize(slotsIndex, playerInfo)
	AutoBarConfigSlot.slots = playerInfo.buttons;
	AutoBarConfigSlot.slotsIndex = slotsIndex;
	getglobal("AutoBarConfigSlotFrameNoPopupText"):SetText(AUTOBAR_CONFIG_NOPOPUP);
	getglobal("AutoBarConfigSlotFrameArrangeOnUseText"):SetText(AUTOBAR_CONFIG_ARRANGEONUSE);
	getglobal("AutoBarConfigSlotFrameRightClickTargetsPetText"):SetText(AUTOBAR_CONFIG_RIGHTCLICKTARGETSPET);
	AutoBarConfigSlot:Update();
	AutoBarConfigSlotFrame:Show();
end


function AutoBarConfigSlot:Update()
	local buttonInfo = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
	local noPopupCheckbox = getglobal("AutoBarConfigSlotFrameNoPopup");
	local arrangeOnUseCheckbox = getglobal("AutoBarConfigSlotFrameArrangeOnUse");
	local rightClickTargetsPetCheckbox = getglobal("AutoBarConfigSlotFrameRightClickTargetsPet");
	local noPopupCheckboxText = getglobal("AutoBarConfigSlotFrameNoPopupText");
	local arrangeOnUseCheckboxText = getglobal("AutoBarConfigSlotFrameArrangeOnUseText");
	local rightClickTargetsPetCheckboxText = getglobal("AutoBarConfigSlotFrameRightClickTargetsPetText");
	local index,tmp,i;

	if (type(buttonInfo) == "table") then
		if (AutoBarConfigSlot.editable) then
			noPopupCheckbox:Enable();
			arrangeOnUseCheckbox:Enable();
			rightClickTargetsPetCheckbox:Enable();

			noPopupCheckboxText:SetVertexColor(NORMAL_FONT_COLOR.r , NORMAL_FONT_COLOR.g , NORMAL_FONT_COLOR.b);
			arrangeOnUseCheckboxText:SetVertexColor(NORMAL_FONT_COLOR.r , NORMAL_FONT_COLOR.g , NORMAL_FONT_COLOR.b);
			rightClickTargetsPetCheckboxText:SetVertexColor(NORMAL_FONT_COLOR.r , NORMAL_FONT_COLOR.g , NORMAL_FONT_COLOR.b);
		end

		noPopupCheckbox:SetChecked(buttonInfo.noPopup);
		arrangeOnUseCheckbox:SetChecked(buttonInfo.arrangeOnUse);
		rightClickTargetsPetCheckbox:SetChecked(buttonInfo.rightClickTargetsPet);

		tmp = 0;
		for index = 1, AUTOBAR_MAXSLOTCATEGORIES, 1 do
			if (buttonInfo[index]) then
				tmp = index;
			end
		end
		index = 1;
		while (index < tmp) do
			if (buttonInfo[index]) then
				index = index + 1;
			else
				buttonInfo[index] =
				buttonInfo[index+1];
				buttonInfo[index+1] = nil;
				tmp = 0;
				for i = 1, AUTOBAR_MAXSLOTCATEGORIES, 1 do
					if (buttonInfo[i]) then
						tmp = i;
					end
				end
			end
		end
	else
		noPopupCheckbox:Disable();
		arrangeOnUseCheckbox:Disable();
		rightClickTargetsPetCheckbox:Disable();

		noPopupCheckboxText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
		arrangeOnUseCheckboxText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
		rightClickTargetsPetCheckboxText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	end

	for index = 1, AUTOBAR_MAXSLOTCATEGORIES, 1 do
		local button   = getglobal("AutoBarConfigSlotFrame_Button"..index);
		local hotkey   = getglobal("AutoBarConfigSlotFrame_Button"..index.."HotKey");
		local count    = getglobal("AutoBarConfigSlotFrame_Button"..index.."Count");
		local icon     = getglobal("AutoBarConfigSlotFrame_Button"..index.."Icon");
		local checkbox = getglobal("AutoBarConfigSlotFrame_Option"..index);
		local checkboxText = getglobal("AutoBarConfigSlotFrame_Option"..index.."Text");

		hotkey:Hide();
		if (type(buttonInfo) == "table") then
			if (buttonInfo[index]) then
				count:SetText("");
				if (AutoBar_Category_Info[buttonInfo[index]] and AutoBar_Category_Info[buttonInfo[index]].targetted) then
					checkbox:Show();
					checkboxText:SetText(AUTOBAR_CONFIG_SMARTSELFCAST);
					if (AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast and AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast[buttonInfo[index]]) then
						checkbox:SetChecked(1);
					else
						checkbox:SetChecked(0);
					end
				else
					checkbox:Hide();
				end
			else
				count:SetText("Empty");
				checkbox:Hide();
			end
			icon:SetTexture(AutoBar_GetTexture(buttonInfo[index]));
			button:Show();
		else
			if (index == 1) then
				icon:SetTexture(AutoBar_GetTexture(buttonInfo));
				button:Show();
				if (buttonInfo) then
					count:SetText("");
					if (AutoBar_Category_Info[buttonInfo] and AutoBar_Category_Info[buttonInfo].targetted) then
						checkbox:Show();
						checkboxText:SetText(AUTOBAR_CONFIG_SMARTSELFCAST);
						if (AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast and AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast[buttonInfo]) then
							checkbox:SetChecked(1);
						else
							checkbox:SetChecked(0);
						end
					else
						checkbox:Hide();
					end
				else
					count:SetText(AUTOBAR_CONFIG_EMPTY);
					checkbox:Hide();
				end
			else
				button:Hide();
				checkbox:Hide();
			end
		end
	end
	---
	if (type(buttonInfo) == "table") then
		AutoBarConfigSlotFrameConvertButton:SetText(AUTOBAR_CONFIG_CONVERTBUTTON1);
	else
		AutoBarConfigSlotFrameConvertButton:SetText(AUTOBAR_CONFIG_CONVERTBUTTON2);
	end
end


-- Individual smart self cast checkbox handling
function AutoBarConfigSlot:SelfCastCheckboxOnCheck()
	local buttonInfo = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
	local category;
	if (type(buttonInfo) == "table") then
		category = buttonInfo[this:GetID()];
	else
		category = buttonInfo;
	end
	if (not AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast) then
		AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast = {};
	end
	AutoBar_Config[AutoBarConfig.editPlayer].smartSelfcast[category] = this:GetChecked();
	AutoBarConfigSlot:Update();
	AutoBarProfile:ButtonsChanged();
end


function AutoBarConfigSlot:OnCheck()
	local buttonInfo = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
	local buttonName = this:GetName();

	if (type(buttonInfo) == "table") then
		if (buttonName == "AutoBarConfigSlotFrameNoPopup") then
			buttonInfo.noPopup = this:GetChecked();
		elseif (buttonName == "AutoBarConfigSlotFrameArrangeOnUse") then
			buttonInfo.arrangeOnUse = this:GetChecked();
		elseif (buttonName == "AutoBarConfigSlotFrameRightClickTargetsPet") then
			buttonInfo.rightClickTargetsPet = this:GetChecked();
		end
	end
	AutoBarConfigSlot:Update();
	AutoBarProfile:ButtonsChanged();
end


function AutoBarConfigSlot:ButtonOnClick(mousebutton)
	ResetCursor();
	AutoBar.dragging = nil;

	if (not AutoBarConfigSlot.editable) then
		return;
	end

	local dragBag, dragSlot = AutoBarConfig:GetDragBagSlot();
	if (CursorHasItem() and dragBag and dragSlot and AutoBarConfigSlot.editable) then
		AutoBarConfigSlot.ButtonOnReceiveDrag();
	else
		local tmp = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
		local category = nil;
		if (type(tmp) == "table") then
			AutoBarChooseCategoryFrame.editting = this:GetID();
			if (AutoBarChooseCategoryFrame.editting > table.getn(tmp) + 1) then
				AutoBarChooseCategoryFrame.editting = table.getn(tmp) + 1;
			end
			category = tmp[AutoBarChooseCategoryFrame.editting];
		else
			AutoBarChooseCategoryFrame.editting = nil;
			category = tmp;
		end

		if (not AutoBarConfigSlot.editable) then
			AutoBarChooseCategoryFrame.editting = nil;
			if (AutoBar_Category_Info[category]) then
				AutoBarChooseCategoryFrame.categoryexplore = category;
			else
				return;
			end
		end

		AutoBarChooseCategoryFrame:Show();
	end
end


function AutoBarConfigSlot.ButtonOnDragStart()
	local fromIndex = this:GetID();
	AutoBar.SetDraggingIndex("AutoBarConfigSlotFrame", fromIndex);
	SetCursor("BUY_CURSOR");
end


function AutoBarConfigSlot.ButtonOnReceiveDrag()
	local toIndex = this:GetID();
	local fromIndex = AutoBar.GetDraggingIndex("AutoBarConfigSlotFrame");

--	DEFAULT_CHAT_FRAME:AddMessage("AutoBarConfig.ButtonOnReceiveDrag " .. tostring(fromIndex) .. " -> " .. toIndex, 1, 0.5, 0);

	if (fromIndex and fromIndex ~= toIndex) then
		AutoBarConfigSlot:MoveButtonItems(AutoBarConfigSlot.slotsIndex, fromIndex, toIndex);
	elseif (CursorHasItem()) then
		local dragBag, dragSlot = AutoBarConfig:GetDragBagSlot();
		if (dragBag and dragSlot) then
			local button = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
			local name, id = AutoBar.LinkDecode(GetContainerItemLink(dragBag, dragSlot));
			if (type(button) == "table") then
				if (table.getn(button) < toIndex) then
					toIndex = table.getn(button) + 1;
				end
				AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex][toIndex] = id;
			else
				AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex] = id;
			end
			dragBag = nil;
			dragSlot = nil;
			ClearCursor();
		end
	end
	AutoBarConfigSlot:Update();
	AutoBarProfile:ButtonsChanged();
	AutoBar.dragging = nil;
	ResetCursor();
end


function AutoBarConfigSlot:MoveButtonItems(button, fromIndex, toIndex)
	if (type(AutoBarConfigSlot.slots[button]) == "table") then
		if (not AutoBarConfigSlot.slots[button][fromIndex] or fromIndex == toIndex) then
			-- Move to self so do nothing
			return;
		end
		if (not AutoBarConfigSlot.slots[button][fromIndex]) then
			-- Dont allow swapping empties into the list
			return;
		end
		local temp = AutoBarConfigSlot.slots[button][fromIndex];
		if (not AutoBarConfigSlot.slots[button][toIndex]) then
			-- Move to the end
			table.remove(AutoBarConfigSlot.slots[button], fromIndex);
			table.insert(AutoBarConfigSlot.slots[button], temp);
		else
			-- Swap the two
			AutoBarConfigSlot.slots[button][fromIndex] = AutoBarConfigSlot.slots[button][toIndex];
			AutoBarConfigSlot.slots[button][toIndex] = temp;
		end
	end
end


-- Toggle between single category slot & multi category slot.
function AutoBarConfigSlot:ConvertSlotButtonOnClick()
	local buttonInfo = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
	local noPopupCheckbox = getglobal("AutoBarConfigSlotFrameNoPopup");
	local arrangeOnUseCheckbox = getglobal("AutoBarConfigSlotFrameArrangeOnUse");
	local rightClickTargetsPetCheckbox = getglobal("AutoBarConfigSlotFrameRightClickTargetsPet");
	local noPopupCheckboxText = getglobal("AutoBarConfigSlotFrameNoPopupText");
	local arrangeOnUseCheckboxText = getglobal("AutoBarConfigSlotFrameArrangeOnUseText");
	local rightClickTargetsPetCheckboxText = getglobal("AutoBarConfigSlotFrameRightClickTargetsPetText");

	if (type(buttonInfo) == "table") then
		local tmp = buttonInfo[1];
		AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex] = tmp;

		noPopupCheckbox:Disable();
		arrangeOnUseCheckbox:Disable();
		rightClickTargetsPetCheckbox:Disable();

		noPopupCheckboxText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
		arrangeOnUseCheckboxText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
		arrangeOnUseCheckboxText:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	else
		local tmp = buttonInfo;
		AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex] = { tmp };
		noPopupCheckbox:Enable();
		arrangeOnUseCheckbox:Enable();
		rightClickTargetsPetCheckbox:Enable();

		noPopupCheckboxText:SetVertexColor(NORMAL_FONT_COLOR.r , NORMAL_FONT_COLOR.g , NORMAL_FONT_COLOR.b);
		arrangeOnUseCheckboxText:SetVertexColor(NORMAL_FONT_COLOR.r , NORMAL_FONT_COLOR.g , NORMAL_FONT_COLOR.b);
		rightClickTargetsPetCheckboxText:SetVertexColor(NORMAL_FONT_COLOR.r , NORMAL_FONT_COLOR.g , NORMAL_FONT_COLOR.b);
	end
	AutoBarConfigSlot:Update();
	AutoBarProfile:ButtonsChanged();
end


-- Delete all items in a slot.
function AutoBarConfigSlot:EmptySlotButtonOnClick()
	local buttonInfo = AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex];
	if (type(buttonInfo) == "table") then
		AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex] = {};
	else
		AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex] = nil;
	end
	AutoBarConfigSlot:Update();
	AutoBarProfile:ButtonsChanged();
end


-- Delete all items in a slot.
function AutoBarConfigSlot:ClearSlotButtonOnClick()
	AutoBarConfigSlot.slots[AutoBarConfigSlot.slotsIndex] = "AAACLEAR";
	AutoBarConfigSlot:Update();
	AutoBarProfile:ButtonsChanged();
end


